> For the complete documentation index, see [llms.txt](https://docs.cosmocloud.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cosmocloud.io/flow-builder/cql-cosmocloud-query-language/building-expressions.md).

# Building Expressions

Expressions are JSON like objects which process and return a specific **calculated** output at the runtime. An expressions object looks like -

## Syntax

```json
{
    <operator>: <value>
}
```

### Properties

| Field       | Description                                                                                                                                                                                                      | Required |
| ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------- |
| \<operator> | A CQL expression operator which defines what type of computation has to be done in this expression. You can check the list of CQL expression operators [**here**](#list-of-expression-objects-available-in-cql). | true     |
| \<value>    | A list or dict of arguments required for the corresponding CQL operator.                                                                                                                                         | true     |

## Restrictions

You can have **at most 1 CQL operator** per expression object.

## Examples

```json
{
    "$add": [1,2,3]
}
```

The above expression will return **6** when used in any node that supports Expressions.

## List of Expression Operators available in CQL

* [$abs](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdabs.md)
* [$add](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdadd.md)
* [$addDate](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdadddate.md)
* [$arrayElemAt](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdarrayelemat.md)
* [$avg](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdavg.md)
* [$buildDateTime](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdbuilddatetime.md)
* [$ceil](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdceil.md)
* [$cond](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdcond.md)
* [$divide](/flow-builder/cql-cosmocloud-query-language/building-expressions/usddivide.md)
* [$floor](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdfloor.md)
* [$ifNull](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdifnull.md)
* [$max](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdmax.md)
* [$min](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdmin.md)
* [$mod](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdmod.md)
* [$multiply](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdmultiply.md)
* [$pow](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdpow.md)
* [$subtract](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdsubtract.md)
* [$sqrt](/flow-builder/cql-cosmocloud-query-language/building-expressions/usdsqrt.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cosmocloud.io/flow-builder/cql-cosmocloud-query-language/building-expressions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
